/* eslint camelcase: "off" */
const FfmpegStreamAudio = require('../FfmpegStreamAudio/FfmpegStreamAudio');
const { toInteger } = require('../FfmpegValidators/FfmpegValidators');

module.exports = class FfmpegStreamAudioInput extends FfmpegStreamAudio {
  /**
   * If some input channel layout is not known, try to guess only if it corresponds to at most the
   * specified number of channels. For example, 2 tells to ffmpeg to recognize 1 channel as mono and
   * 2 channels as stereo but not 6 channels as 5.1. The default is to always try to guess. Use 0 to
   * disable all guessing.
   */
  guess_layout_max(channels) {
    try {
      const asInt = toInteger(channels);
      this.addOption('-guess_layout_max', asInt);
    } catch (error) {
      throw new TypeError('guess_layout_max requires an integer argument.');
    }

    return this;
  }
};
